#!/bin/bash
#
# --- o2tower.sh ---
# v2.40 Mar08 JS adaptions to spinpack v2.33 output, use "conv=" lines
# v2.39 Jun07 JS printf %f of awk is LANG dependent, we want the x.y-format
# v2.38 Mai05 JS dublication-bug removed ("no convergence") triggered "/erg/" 
# v2.37 Oct04 JS adapted to new output of fulldiag
# v2.36 Feb04 JS correct rounding for negativ values
# v2.35 Apr00 JS ??? if no convergence detected
# v2.34 Apr00 JS ud=+/- added
# v2.33 Mar00 JS bug if erg1==erg2 && ss1>ss2 (ss2 taken), num2 incorrekt
# v2.32 Feb00 JS see line 55!
VER=2.40
#
# convert spin-output file into gnuplot-dat file for energy-spectrum
#
# fulldiag for all sz=0..n/2
#
# 1) extract sym, converged erg, sz
# 2) sort erg
# 3) remove dublicate values (also fold
#
# awk.function is not supported by SunOS.awk (no abs, no sign, no function)
# define maximum precision, if (abs(e1-e2)<=prec) e1 and e2 treated as equal
LANG=C    # printf %f of awk is language dependent, we want the x.y-format
prec=1e-6  
awk -v prec=$prec \
 'BEGIN {estr=100.0;erg=100.0;num=20;line1="";line2="";n1=0;algo=0;nn=0;}
     # --- get the 2nd last line of iteration output, store for later
     /i100=/{algo=0;line2=line1;line1=$0;if(length(line2)==0)line2=line1}
     /eigenvals=/{algo=4;num=NF-1; # get results from full-diag
       for( i1=0; i1<num; i1++){
          printf "%4g %12.8f q%s\n",sz,$(i1+2),sym
       }
     } 
     /conv=/ { i2=1; num=NF-1; num2=split(line2,a1) # create array a1
       for( i1=0; i1<num; i1++){   # each element (energy) of that line
         estr=$(i1+2);
         # do not output dublicate values
         if(estr!=erg && i2<=n1 && ( i3<=i1 || n1<num ) ){
           printf "%4g %12.8f q%s\n",sz,estr,sym;
           erg=estr; i2=(i2+1)   # count different energies
         }
       }
     }
     /k_T/ { sym=$4; sud=$2;  }
     /N,nu,nd/ { sz=($4-$3)/2;if(sz<0)sz=-sz;n1=$6;nn=$4+$3;
       if(sz==0){ if(sud==0)sym=sym"+";else sym=sym"-"; }
     }
' -  | if true; then sort -n -k 2 -k 1; else cat; fi \
| if which gawk >/dev/null; then     # skip if gawk is not available
 awk -v VER=$VER ' function fun1(){
         sum+=num; esum+=num*erg;
         printf "%4g %12.8f %3d %s %s",ss,erg,num,sym,rest; num=0;
         if(ss>smin){ smin=ss; printf " low"}
         printf "\n";
        }
      BEGIN { erg=0.0;ss=-1;smin=-1;line="";num=0;sum=0;esum=0;sym="";rest="";
         for(i=0;i<60;i++) ea[i]=0;  # entartung[ss]
	 printf "# o2tower.sh v%s\n#S erg	ea? sym remark\n",VER }
      END { fun1(); printf "# sum_ea=%d sum_erg=%13.8f\n",sum,esum }
     !/^#/{
       if(erg!=$2 && ss>=0){ fun1(); }
       if(erg!=$2 || (erg==$2 && ss<$1)){ ss=$1; }
       if(erg!=$2) sym=$3;
       if(index(sym,$3)==0) sym=sym" "$3;
       erg=$2;line=$0;rest=$4; ea[ss]++;
       if(ss>=0){ num=num+1;if(ss>0)num=num+1; }
     }
     /^#/{print}'
else cat; fi
